<?PHP
/**
* @desc wmWorker -      WebMoney
*          WMSigner     Webmoney
*    (  http://www.webmoney.ru/rus/developers/interfaces/xml/authdescr/index.shtml)
*    - : http://www.webmoney.ru/rus/developers/interfaces/xml/index.shtml
* : PHP5    CURL
*  :
*   $wm = new wmWorker('254500137691','/home/onimusic/domains/kredit.sumy.ua/public_html/WebMoneyCA.cer','/home/onimusic/domains/kredit.sumy.ua/public_html/keys');
*   $result = $wm->wm_X3Req($generated_id,'Z134669242980','20080501 00:00:01', '20080530 23:59:59');
*   if($result===false) echo ": ".$wm-Error;
*   else print_r($result);
*/
Class wmWorker{
    public $Site = 'http://kredit.sumy.ua';                                   // site name
    public $WMID = '254500137691';                                   // WMID
    private $WMSigner = 'wmsigner.php';                              // path to WMSigner
    private $CAcert = 'WebMoneyCA.cer';                                // path to WebMoney CA cert
    private $URL = 'https://w3s.webmoney.ru/asp/';       // URL to w3s server with ending '/'  (https://w3s.webmoney.ru/asp/  or  https://w3s.wmtransfer.com/asp/)
    public $Error = '';                                  //  
    public $TestMode = false;                            //   -    
    public $CodeTable = 'WINDOWS-1251';                  //     
    //   
    public $StatusCodes = array(
            0=>' ',
            1=>'  ',
            2=>'    ',
            3=>''
        );
    //   ()
    public $OperationCodes = array(
            0=>'  (      )',
            4=>'   ( )',
            12=>'   ,        -     (8)'
        );
    
    /**
    * @desc wmWorker object constructor
    * @param string - WMID
    * @param string -   -    
    * @param string -   WMSigner- -  
    * @param boolean -   (     )
    */
    function wmWorker($setwmWMID,$setwmCAcert,$setwmWMSigner,$setwmTestmode=false){
        $this->WMID = $setwmWMID;
        $this->Site = $_SERVER['SERVER_NAME'];
        $this->WMSigner = $setwmWMSigner;
        $this->CAcert = $setwmCAcert;
        $this->TestMode = $setwmTestmode;
    }

    /** 
    * @desc wm_GetSign - WebMoney signing string
    * @param string for signing
    * @return string|false - string - result of signing | false - incorrect signing (errortext in wmError)
    */
    private function GetSign($inStr) { 
        if($this->TestMode) echo "<b># Begin</b> GetSign: '".$inStr."'<br>";
        $descriptorspec = array(        
                0 => array("pipe", "r"),
                1 => array("pipe", "w"),
                2 => array("pipe", "r") );
        $process = proc_open($this->WMSigner, $descriptorspec, $pipes);
        if($this->TestMode) echo " - proc_open : ".($process===false ? 'error' : 'ok')."<br>";
        if (is_resource($process)) {
            fwrite($pipes[0], "$inStr\004\r\n");
            fclose($pipes[0]);
            $s = fgets($pipes[1], 133);
            if($this->TestMode) echo " - fgets : '".htmlspecialchars($s)."'<br>";
            fclose($pipes[1]);
            $return_value = proc_close($process);
            if(strlen($s)<132){
                if($this->TestMode) echo " - result incorrect!<br>";
                $this->Error = "WMSigner error: '$s'";
                return false;
            };
            return $s;
        }
        $this->Error = "WMSigner error: can not create a process";
        return false;
    }

    /** 
    * @desc xmlHttpsReq - https query at w3s.webmoney.ru (w3s.wmtransfer.com)
    * @param string - interface URL (ex: "XMLPurses.asp")
    * @param string - XML request as string
    * @return string|false - Result CURL excecution https-query (without headers) | false - incorrect query (errortext in wmError)
    */
    private function xmlHttpsReq($addr, $xml){ 
        if($this->TestMode) echo "<b># Begin</b> xmlHttpsReq: '".$addr."','".nl2br(htmlspecialchars($xml))."'<br>";
        $ch = curl_init(substr($addr, 0, 4) == "http" ? $addr : $this->URL.$addr);
        if($this->TestMode) echo " - full addr: '".(substr($addr, 0, 4) == "http" ? $addr : $this->URL.$addr)."'<br>";
        curl_setopt($ch, CURLOPT_HEADER, 0);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER,1);
        curl_setopt($ch, CURLOPT_POST,1);
        curl_setopt($ch, CURLOPT_POSTFIELDS,$xml);
        #      WebMoney CA:
        curl_setopt($ch, CURLOPT_CAINFO, $this->CAcert);
        # !   curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE)!
        #        DNS.
        $result=curl_exec($ch);
        if($this->TestMode) echo " - CURL result : '".htmlspecialchars(iconv("UTF-8",$this->WorkCodeTable,$result))."'<br>";
        if(curl_errno($ch) != 0){
            $this->Error = 'CURL_error: '.curl_errno($ch).', '.curl_error($ch);
            return false;
        }
        curl_close($ch);
        return $result;
    }

    /**
    * @desc CheckResp - check w3s.response
    * @param array - 'vals' var after xml_parse_into_struct() response
    * @param array - 'index' var after xml_parse_into_struct() response
    * @return 0|string - 0 - if all OK | string - if error then error description
    */
    private function CheckResp($vals, $index){
        if($this->TestMode) {
            echo "<b># Begin</b> CheckResp<br>";
            //print_r($index);
            //echo "<hr>";
            //print_r($vals);
            //echo "</pre>";
        }
        $retval_idx = $index['RETVAL'][0];
        if (!$retval_idx){
            if(!isset($vals[$index['RESPONSE'][0]]['attributes']['RETVAL'])){
                if($this->TestMode) echo " - no retval!!!<br>";
                $this->Error = "Incorrect response (no retval)";
                return false;
            }
        }
        if (!$retval_idx) $retval = $vals[$index['RESPONSE'][0]]['attributes']['RETVAL'];
            else $retval = $vals[$retval_idx]['value'];
        if ($retval != 0) {
            $desc_idx = $index['RETDESC'][0];
            if($this->TestMode) echo " - error in response!!!<br>";
            if (!$desc_idx) $this->Error = "Incorrect response (no retdesc)";
            else $this->Error = "Incorrect response: ".iconv("UTF-8",$this->CodeTable,$vals[$desc_idx]['value']);
            return false;
        }
        return true;
    }

    /**
    * @desc XML_Parse parse and check XML from response
    * @param string - XML
    * @return array|false - array of correct vals | false - error in responce
    */
    private function wm_XML_Parse($XMLString){
        $XMLString = preg_replace("!>[\s]+<!Ums", "><", $XMLString);
        if($this->TestMode) {
            echo "<b># Begin</b> wm_XML_Parse<br>";
            echo " - input XML : '".htmlspecialchars($XMLString)."'<br>";
        }
        $xml_parser = xml_parser_create('UTF-8');
        $res = xml_parse_into_struct($xml_parser, $XMLString, $vals, $index);
        if($res===0){
            if($this->TestMode) echo "XML parser error ".xml_get_error_code($xml_parser).": ".xml_error_string(xml_get_error_code($xml_parser))."<br>";
            $this->Error = "XML parser error ".xml_get_error_code($xml_parser).": ".xml_error_string(xml_get_error_code($xml_parser));
            return false;
        }
        xml_parser_free($xml_parser);
        if($this->CheckResp($vals,$index)===false) return false;
        return $vals;
    }

    /**
    * @desc X9Req - X9 interface query ( )
    * @param string - unique identifier
    * @return array|false [ pursename => array [ 'amount' => amount, 'desc' => description ]] | false - error (errortext in wmError)
    */
    public function X9Req($reqID){
        if($this->TestMode) echo "<b># Begin</b> X9Req: '".$reqID."'<br>";
        if (intval($reqID) < 1){
            $this->Error = "Request error: no reqn param";
            return false;
        }
        $wmSign = $this->GetSign($this->WMID.$reqID);
        if($wmSign===false) return false;
        if($this->TestMode) echo " - sign OK<br>";
        $addr = 'XMLPurses.asp';
        $request =  '<w3s.request>'.
                    '<sign>'.$wmSign.'</sign>'.
                    '<reqn>'.$reqID.'</reqn>'.
                    '<wmid>'.$this->WMID.'</wmid>'.
                    '<getpurses>'.
                    '<wmid>'.$this->WMID.'</wmid>'.
                    '</getpurses>'.
                    '</w3s.request>';
        $result = $this->xmlHttpsReq($addr, $request);
        if($result===false) return false;
        if($this->TestMode) echo " - request OK<br>";
        $vals = $this->wm_XML_Parse($result);
        if($vals===false) return false;
        if($this->TestMode) echo " - parse OK<br>";
        $purses = array();
        for($n = 0; $n < count($vals); ++$n){
            $e = $vals[$n];
            switch ($e['tag']){
                case 'PURSE':
                    switch ($e['type']){
                        case 'open':
                                $pursename = ''; $amount = ''; $desc = '';
                                break;
                        case 'close':
                                $purses[$pursename] = array('amount' => $amount, 'desc' => $desc);
                                break;
                    }
                    break;
                case 'PURSENAME':
                    $pursename = $e['value'];
                    break;
                case 'AMOUNT':
                    $amount = $e['value'];
                    break;
                case 'DESC':
                    $desc = iconv("UTF-8",$this->CodeTable,$e['value']); 
                    break;
            }
        }
        return $purses;    
    }

    /**
    * @desc X2Req - X2 interface query (      )
    * @param string -     ( 15 )
    * @param int -   
    * @param string - -
    * @param string - -
    * @param float -  
    * @param string -  
    * @param int(32) -   (  WebMoney),     (0 -    )
    * @param int -     
    * @param string -   ( 255 )
    * @return array|false [ pursename => array [ 'amount' => amount, 'desc' => description ]] | false - error (errortext in Error)
    */
    public function X2Req($reqID, $tranID, $pursesrc, $pursedest, $amount, $descr, $wminvid=0, $period=0, $pcode=''){
        if (intval($reqID) < 1){
            $this->Error = "Request error: no reqn param";
            return false;
        }
        if($period==0) {
            $pcode='';
        } elseif(strlen($pcode)==0 || strlen($pcode)>255){
            $this->Error = "Request error: incorrect protection code";
            return false;
        }
        $wmSign = $this->GetSign($reqID.$tranID.$pursesrc.$pursedest.$amount.'0'.''.$descr.$wminvid);
        if($wmSign === false) return false;
        $request = '
    <w3s.request>
        <reqn>'.$reqID.'</reqn>
        <wmid>'.$this->WMID.'</wmid>
        <sign>'.$wmSign.'</sign>
        <trans>
            <tranid>'.$tranID.'</tranid>
            <pursesrc>'.$pursesrc.'</pursesrc>
            <pursedest>'.$pursedest.'</pursedest>
            <amount>'.$amount.'</amount>
            <period>'.$period.'</period>
            <pcode>'.$pcode.'</pcode>
            <desc>'.iconv($this->CodeTable, "UTF-8", $descr).'</desc>
            <wminvid>'.$wminvid.'</wminvid>
        </trans>
    </w3s.request>';
        $addr = 'XMLTrans.asp';
        $result = $this->xmlHttpsReq($addr, $request);
        if($result === false) return false;
        $vals = $this->wm_XML_Parse($result);
        if($vals===false) return false;
        $return = array();
        for($n = 0; $n < count($vals); ++$n){
            if (in_array($vals[$n]['tag'], array("REQN", "RETVAL", "RETDESC", "TRANID", "PURSESRC", "PURSEDEST", "AMOUNT", "COMISS")))
            {
                $return[$vals[$n]['tag']] = iconv("UTF-8",$this->CodeTable,$vals[$n]['value']);
            }
            elseif ($vals[$n]['tag'] == "OPERATION" && $vals[$n]['type'] == "open")
            {
                $return["OPERATION_ID"] = $vals[$n]['attributes']['ID'];
                $return["OPERATION_TS"] = $vals[$n]['attributes']['TS'];
            }
        }
        return $return;
    }
    
    /**
    * @desc X6Req - X6 interface query (   WM-   )
    * @param string -     ( 15 )
    * @param string - WM-   (12 )
    * @param string -   (1-255 )
    * @param string -   (1-1024 )
    * @return array|false [ pursename => array [ 'amount' => amount, 'desc' => description ]] | false - error (errortext in Error)
    */
    public function X6Req($reqID, $toWMID, $text, $subject){
        if(strlen($text)<1 || strlen($text)>1024){
            $this->Error = "Request error: text is empty or too big";
            return false;
        }
        if(strlen($subject)<1 || strlen($subject)>255){
            $this->Error = "Request error: subject is empty or too big";
            return false;
        }
        $request = 
    '<w3s.request>
        <reqn>'.$reqID.'</reqn>
        <wmid>'.$this->WMID.'</wmid>
        <sign>'.$this->GetSign($toWMID.$reqID.$text.$subject).'</sign>
        <message>
            <receiverwmid>'.$toWMID.'</receiverwmid>
            <msgsubj>'.iconv($this->CodeTable,"UTF-8",$subject).'</msgsubj>
            <msgtext>'.iconv($this->CodeTable,"UTF-8",$text).'</msgtext>
        </message>
    </w3s.request>';
        $addr = 'XMLSendMsg.asp';
        $result = $this->xmlHttpsReq($addr, $request);
        if($result === false) return false;
        $vals = $this->wm_XML_Parse($result);
        if($vals===false) return false;
        $return = array();
        for($n = 0; $n < count($vals); ++$n){
            if (in_array($vals[$n]['tag'], array("REQN", "RETVAL", "RETDESC", "TRANID", "PURSESRC", "PURSEDEST", "AMOUNT", "COMISS")))
            {
                $return[$vals[$n]['tag']] = iconv("UTF-8",$this->CodeTable,$vals[$n]['value']);
            }
            elseif ($vals[$n]['tag'] == "OPERATION" && $vals[$n]['type'] == "open")
            {
                $return["OPERATION_ID"] = $vals[$n]['attributes']['ID'];
                $return["OPERATION_TS"] = $vals[$n]['attributes']['TS'];
            }
        }
        return $return;    
    }

    /**
    * @desc X11Req - X11 interface query (    WM      )
    * @param string -     ( 15 )
    * @param string -  WM- (12 )
    * @param int -  " " [0  1]
    * @param int -    [0  1]
    * @param int -   WM ,  ,       [0  1]
    * @return array|false [ pursename => array [ 'amount' => amount, 'desc' => description ]] | false - error (errortext in Error)
    */
    public function X11Req($reqID, $toWMID, $dict=0, $info=0, $mode=0){
        $request = 
    '<request>
        <reqn>'.$reqID.'</reqn>
        <wmid>'.$this->WMID.'</wmid>
        <passportwmid>'.$toWMID.'</passportwmid>
        <sign>'.$this->GetSign($wmWMID.$toWMID).'</sign>
        <params>
            <dict>'.$dict.'</dict>
            <info>'.$info.'</info>
            <mode>'.$mode.'</mode>
        </params>
    </request>';
        $addr = 'https://passport.webmoney.ru/asp/XMLGetWMPassport.asp';//'XMLGetWMPassport.asp';
        $result = $this->xmlHttpsReq($addr, $request);
        if($result === false) return false;
        $vals = $this->wm_XML_Parse($result);
        if($vals===false) return false;
        $return = array();
        for($n = 0; $n < count($vals); ++$n){
            switch($vals[$n]['tag']){
                case "RESPONSE":
                    $return["RETVAL"] = $vals[$n]['attributes']['RETVAL'];
                    break;
                case "FULLACCESS":
                    $return[$vals[$n]['tag']] = $vals[$n]['value'];
                    break;
                case "CERTINFO":
                    if($vals[$n]['type'] == "open"){
                        foreach($vals[$n]['attributes'] as $attr_key=>$attr_value)
                            $return[$vals[$n]['tag']][strtoupper($attr_key)] = iconv("UTF-8",$this->CodeTable,$attr_value);
                    }
                    break;
             //       
             // (  http://passport.webmoney.ru/asp/infoXMLGetWMPassport.asp)
            }
        }
        return $return;
    }
    /**
    * @desc X1Req - X1 interface query (     (, )   ())
    * @param string -     ( 15 )
    * @param int -      ;     
    * @param string - WMId 
    * @param string -  ,     
    * @param float -  ,     (    ( - .() ))
    * @param string -    ,     (   0  255 )
    * @param string -    (   0  255 )
    * @param int -           (   0  255,  0 -       )
    * @param int -        (   0  255;  0 -    )
    */
    public function X1Req($reqID, $orderid, $customerwmid, $storepurse, $amount, $desc, $address='', $period=0, $expiration=0){
        if (intval($reqID) < 1){
            $this->Error = "Request error: no reqn param";
            return false;
        }
        $wmSign = $this->GetSign($orderid.$customerwmid.$storepurse.$amount.$desc.$address.$period.$expiration.$reqID);
        if($wmSign === false) return false;
        $request = '
    <w3s.request>
        <reqn>'.$reqID.'</reqn>
        <wmid>'.$this->WMID.'</wmid>
        <sign>'.$wmSign.'</sign>
        <invoice>
            <orderid>'.$orderid.'</orderid>
            <customerwmid>'.$customerwmid.'</customerwmid>
            <storepurse>'.$storepurse.'</storepurse>
            <amount>'.$amount.'</amount>
            <desc>'.iconv($this->CodeTable,"UTF-8",$desc).'</desc>
            <address>'.iconv($this->CodeTable,"UTF-8",$address).'</address>
            <period>'.$period.'</period>
            <expiration>'.$expiration.'</expiration>
        </invoice>
    </w3s.request>';
        $addr = 'XMLInvoice.asp';
        $result = $this->xmlHttpsReq($addr, $request);
        if($result === false) return false;
        $vals = $this->wm_XML_Parse($result);
        if($vals===false) return false;
        $return = array();
        for($n = 0; $n < count($vals); ++$n){
            if (in_array($vals[$n]['tag'], array("REQN", "RETVAL", "RETDESC", "ORDERID", "CUSTOMERWMID", "STOREPURSE", "AMOUNT", "DESC", "ADDRESS", "PERIOD", "EXPIRATION", "STATE", "DATECRT", "DATEUPD")))
            {
                $return[$vals[$n]['tag']] = iconv("UTF-8",$this->CodeTable,$vals[$n]['value']);
                if($vals[$n]['tag'] == "STATE") $return['STATE_DESC'] = $this->StatusCodes[intval($vals[$n]['value'])];
            }
            elseif ($vals[$n]['tag'] == "INVOICE" && $vals[$n]['type'] == "open")
            {
                $return["INVOICE_ID"] = $vals[$n]['attributes']['ID'];
                $return["INVOICE_TS"] = $vals[$n]['attributes']['TS'];
            }
        }
        return $return;
    }
    /**
    * @desc X3Req - X3 interface query (    .      )
    * @param string -     ( 15 )
    * @param string -      
    * @param string -       ( ::) -   - 3 .
    * @param string -       ( ::) -   - 3 .
    * @param int -   (  WebMoney)
    * @param int -      
    * @param int -   (  WebMoney)    
    * @param int -      
    */
    public function X3Req($reqID, $purse, $datestart, $datefinish, $wmtranid=0, $tranid=0, $wminvid=0, $orderid=0){
        if (intval($reqID) < 1){
            $this->Error = "Request error: no reqn param";
            return false;
        }
        $wmSign = $this->GetSign($purse.$reqID);
        if($wmSign === false) return false;
        $request = '
    <w3s.request>
        <reqn>'.$reqID.'</reqn>
        <wmid>'.$this->WMID.'</wmid>
        <sign>'.$wmSign.'</sign>
        <getoperations>
            <purse>'.$purse.'</purse>
            <wmtranid>'.($wmtranid==0 ? '' : $wmtranid).'</wmtranid>
            <tranid>'.($tranid==0 ? '' : $tranid).'</tranid>
            <wminvid>'.($wminvid==0 ? '' : $wminvid).'</wminvid>
            <orderid>'.($orderid==0 ? '' : $orderid).'</orderid>
            <datestart>'.$datestart.'</datestart>
            <datefinish>'.$datefinish.'</datefinish>
        </getoperations>
    </w3s.request>';
        $addr = 'XMLOperations.asp';
        $result = $this->xmlHttpsReq($addr, $request);
        if($result === false) return false;
        $vals = $this->wm_XML_Parse($result);
        if($vals===false) return false;
        $return = array();
        $cnt = 0;
        for($n = 0; $n < count($vals); ++$n){
            switch($vals[$n]['tag']){
                case "REQN":
                case "RETVAL":
                case "RETDESC":
                    $return[$vals[$n]['tag']] = $vals[$n]['value'];
                    break;
                case "OPERATIONS":
                    if($vals[$n]['type'] == "open"){
                        $return["OPERATIONS_CNT"] = $vals[$n]['attributes']['CNT'];
                        $return["OPERATIONS"] = array();
                    }
                    break;
                case "OPERATION":
                    switch($vals[$n]['type']){
                        case "open":
                            $return["OPERATIONS"][$cnt]["OPERATION_ID"] = $vals[$n]['attributes']['ID'];
                            $return["OPERATIONS"][$cnt]["OPERATION_TS"] = $vals[$n]['attributes']['TS'];
                            break;
                        case "close":
                            $cnt++;
                            break;
                    }
                    break;
                case "OPERTYPE":
                    $return["OPERATIONS"][$cnt]["OPERTYPE_DESC"] = $this->OperationCodes[intval($vals[$n]['value'])];
                case "TRANID":
                case "PURSESRC":
                case "PURSEDEST":
                case "AMOUNT":
                case "COMISS":
                case "PERIOD":
                case "WMINVID":
                case "ORDERID":
                case "DESC":
                case "DATECRT":
                case "DATEUPD":
                case "CORRWM":
                case "REST":
                    $return["OPERATIONS"][$cnt][$vals[$n]['tag']] = iconv("UTF-8",$this->CodeTable,$vals[$n]['value']);
                    break;
            }
        }
        return $return;
    }

    /**
    * @desc X4Req X4 interface query (     .   )
    * @param string -     ( 15 )
    * @param string -      
    * @param string -       ( ::) -   - 3 .
    * @param string -       ( ::) -   - 3 .
    * @param int -   (  WebMoney)    
    * @param int -      
    */
    public function X4Req($reqID, $purse, $datestart, $datefinish, $wminvid=0, $orderid=0){
        if (intval($reqID) < 1){
            $this->Error = "Request error: no reqn param";
            return false;
        }
        $wmSign = $this->GetSign($purse.$reqID);
        if($wmSign === false) return false;
        $request = '
    <w3s.request>
        <reqn>'.$reqID.'</reqn>
        <wmid>'.$this->WMID.'</wmid>
        <sign>'.$wmSign.'</sign>
        <getoutinvoices>
            <purse>'.$purse.'</purse>
            <wminvid>'.$wminvid.'</wminvid>
            <orderid>'.$orderid.'</orderid>
            <datestart>'.$datestart.'</datestart>
            <datefinish>'.$datefinish.'</datefinish>
        </getoutinvoices>
    </w3s.request>';
        $addr = 'XMLOutInvoices.asp';
        $result = $this->xmlHttpsReq($addr, $request);
        if($result === false) return false;
        $vals = $this->wm_XML_Parse($result);
        if($vals===false) return false;
        $return = array();
        $cnt = 0;
        for($n = 0; $n < count($vals); ++$n){
            switch($vals[$n]['tag']){
                case "REQN":
                case "RETVAL":
                case "RETDESC":
                    $return[$vals[$n]['tag']] = $vals[$n]['value'];
                    break;
                case "OUTINVOICES":
                    if($vals[$n]['type'] == "open"){
                        $return["OUTINVOICES_CNT"] = $vals[$n]['attributes']['CNT'];
                        $return["OUTINVOICES"] = array();
                    }
                    break;
                case "OUTINVOICE":
                    switch($vals[$n]['type']){
                        case "open":
                            $return["OUTINVOICES"][$cnt]["OUTINVOICE_ID"] = $vals[$n]['attributes']['ID'];
                            $return["OUTINVOICES"][$cnt]["OUTINVOICE_TS"] = $vals[$n]['attributes']['TS'];
                            break;
                        case "close":
                            $cnt++;
                            break;
                    }
                    break;
                case "STATE":
                    $return["OUTINVOICES"][$cnt]["STATE_DESC"] = $this->StatusCodes[intval($vals[$n]['value'])];
                case "ORDERID":
                case "CUSTOMERWMID":
                case "STOREPURSE":
                case "AMOUNT":
                case "DESC":
                case "ADDRESS":
                case "PERIOD":
                case "EXPIRATION":
                case "DATECRT":
                case "DATEUPD":
                case "WMTRANID":
                case "CUSTOMERPURSE":
                    $return["OUTINVOICES"][$cnt][$vals[$n]['tag']] = iconv("UTF-8",$this->CodeTable,$vals[$n]['value']);
                    break;
            }
        }
        return $return;
    }
    /**
    * @desc X5Req - X5 interface query (    .   )
    * @param string -     ( 15 )
    * @param int -       WebMoney (   )
    * @param string -    (   1  255 )
    */
    public function X5Req($reqID, $wmtranid, $pcode){
        if (intval($reqID) < 1){
            $this->Error = "Request error: no reqn param";
            return false;
        }
        $wmSign = $this->GetSign($wmtranid.$pcode.$reqID);
        if($wmSign === false) return false;
        $request = '
    <w3s.request>
        <reqn>'.$reqID.'</reqn>
        <wmid>'.$this->WMID.'</wmid>
        <sign>'.$wmSign.'</sign>
      <finishprotect>
        <wmtranid>'.$wmtranid.'</wmtranid>
        <pcode>'.$pcode.'</pcode>
      </finishprotect>
    </w3s.request>';
        $addr = 'XMLFinishProtect.asp';
        $result = $this->xmlHttpsReq($addr, $request);
        if($result === false) return false;
        $vals = $this->wm_XML_Parse($result);
        if($vals===false) return false;
        $return = array();
        for($n = 0; $n < count($vals); ++$n){
            switch($vals[$n]['tag']){
                case "OPERTYPE":
                    $return["OPERTYPE_DESC"] = $this->OperationCodes[intval($vals[$n]['value'])];
                case "REQN":
                case "RETVAL":
                case "RETDESC":
                case "DATEUPD":
                    $return[$vals[$n]['tag']] = iconv("UTF-8",$this->CodeTable,$vals[$n]['value']);
                    break;
                case "OPERATION":
                    if($vals[$n]['type'] == "open"){
                            $return["OPERATION_ID"] = $vals[$n]['attributes']['ID'];
                            $return["OPERATION_TS"] = $vals[$n]['attributes']['TS'];
                    }
                    break;
            }
        }
        return $return;
    }

    /**
    * @desc X13Req - X13 interface query (    )
    * @param string -     ( 15 )
    * @param int -       WebMoney (   )
    */
    public function X13Req($reqID, $wmtranid){
        if (intval($reqID) < 1){
            $this->Error = "Request error: no reqn param";
            return false;
        }
        $wmSign = $this->GetSign($wmtranid.$reqID);
        if($wmSign === false) return false;
        $request = '
    <w3s.request>
        <reqn>'.$reqID.'</reqn>
        <wmid>'.$this->WMID.'</wmid>
        <sign>'.$wmSign.'</sign>
        <rejectprotect>
            <wmtranid>'.$wmtranid.'</wmtranid>
        </rejectprotect>
    </w3s.request>';
        $addr = 'XMLRejectProtect.asp';
        $result = $this->xmlHttpsReq($addr, $request);
        if($result === false) return false;
        $vals = $this->wm_XML_Parse($result);
        if($vals===false) return false;
        $return = array();
        for($n = 0; $n < count($vals); ++$n){
            switch($vals[$n]['tag']){
                case "OPERTYPE":
                    $return["OPERTYPE_DESC"] = $this->OperationCodes[intval($vals[$n]['value'])];
                case "REQN":
                case "RETVAL":
                case "RETDESC":
                case "DATEUPD":
                    $return[$vals[$n]['tag']] = iconv("UTF-8",$this->WorkCodeTable,$vals[$n]['value']);
                    break;
                case "OPERATION":
                    if($vals[$n]['type'] == "open"){
                            $return["OPERATION_ID"] = $vals[$n]['attributes']['ID'];
                            $return["OPERATION_TS"] = $vals[$n]['attributes']['TS'];
                    }
                    break;
            }
        }
        return $return;
    }

    /**
    * @desc X14Req - X14 interface query (   )
    * @param string -     ( 15 )
    * @param int -       WebMoney (   )
    * @param float -   (       ,     )
    */
    public function X14Req($reqID, $inwmtranid, $amount){
        if (intval($reqID) < 1){
            $this->Error = "Request error: no reqn param";
            return false;
        }
        $wmSign = $this->GetSign($reqID.$inwmtranid.$amount);
        if($wmSign === false) return false;
        $request = '
    <w3s.request>
        <reqn>'.$reqID.'</reqn>
        <wmid>'.$this->WMID.'</wmid>
        <sign>'.$wmSign.'</sign>
        <trans>
            <inwmtranid>'.$inwmtranid.'</inwmtranid>
            <amount>'.$amount.'</amount>
        </trans>
    </w3s.request>';
        $addr = 'XMLTransMoneyback.asp';
        $result = $this->xmlHttpsReq($addr, $request);
        if($result === false) return false;
        $vals = $this->wm_XML_Parse($result);
        if($vals===false) return false;
        $return = array();
        for($n = 0; $n < count($vals); ++$n){
            switch($vals[$n]['tag']){
                case "REQN":
                case "RETVAL":
                case "RETDESC":
                case "INWMTRANID":
                case "PURSESRC":
                case "PURSEDEST":
                case "AMOUNT":
                case "COMISS":
                case "DESC":
                case "DATECRT":
                case "DATEUPD":
                    $return[$vals[$n]['tag']] = iconv("UTF-8",$this->CodeTable,$vals[$n]['value']);
                    break;
                case "OPERATION":
                    if($vals[$n]['type'] == "open"){
                            $return["OPERATION_ID"] = $vals[$n]['attributes']['ID'];
                            $return["OPERATION_TS"] = $vals[$n]['attributes']['TS'];
                    }
                    break;
            }
        }
        return $return;
    }

    /**
    * @desc X10Req - X10 interface query (    )
    * @param string -     ( 15 )
    * @param int - WM-,    ()  
    * @param string -       ( ::) -   - 3 .
    * @param string -       ( ::) -   - 3 .
    * @param int -   (  WebMoney)
    */
    public function X10Req($reqID, $wmid, $datestart, $datefinish, $wminvid=0){
        if (intval($reqID) < 1){
            $this->Error = "Request error: no reqn param";
            return false;
        }
        $wmSign = $this->GetSign($wmid.$wminvid.$datestart.$datefinish.$reqID);
        if($wmSign === false) return false;
        $request = '
    <w3s.request>
        <reqn>'.$reqID.'</reqn>
        <wmid>'.$this->WMID.'</wmid>
        <sign>'.$wmSign.'</sign>
        <getininvoices>
            <wmid>'.$wmid.'</wmid>
            <wminvid>'.$wminvid.'</wminvid>
            <datestart>'.$datestart.'</datestart>
            <datefinish>'.$datefinish.'</datefinish>
        </getininvoices>
    </w3s.request>';
        $addr = 'XMLInInvoices.asp';
        $result = $this->xmlHttpsReq($addr, $request);
        if($result === false) return false;
        $vals = $this->wm_XML_Parse($result);
        if($vals===false) return false;
        $return = array();
        $cnt=0;
        for($n = 0; $n < count($vals); ++$n){
            switch($vals[$n]['tag']){
                case "REQN":
                case "RETVAL":
                case "RETDESC":
                    $return[$vals[$n]['tag']] = $vals[$n]['value'];
                    break;
                case "ININVOICES":
                    if($vals[$n]['type'] == "open"){
                        $return["ININVOICES_CNT"] = $vals[$n]['attributes']['CNT'];
                        $return["ININVOICES"] = array();
                    }
                    break;
                case "ININVOICE":
                    switch($vals[$n]['type']){
                        case "open":
                            $return["ININVOICES"][$cnt]["ININVOICE_ID"] = $vals[$n]['attributes']['ID'];
                            $return["ININVOICES"][$cnt]["ININVOICE_TS"] = $vals[$n]['attributes']['TS'];
                            break;
                        case "close":
                            $cnt++;
                            break;
                    }
                    break;
                case "STATE":
                    $return["ININVOICES"][$cnt]["STATE_DESC"] = $this->StatusCodes[intval($vals[$n]['value'])];
                case "ORDERID":
                case "STOREWMID":
                case "STOREPURSE":
                case "AMOUNT":
                case "DESC":
                case "ADDRESS":
                case "PERIOD":
                case "EXPIRATION":
                case "DATECRT":
                case "DATEUPD":
                case "WMTRANID":
                    $return["ININVOICES"][$cnt][$vals[$n]['tag']] = iconv("UTF-8",$this->CodeTable,$vals[$n]['value']);
                    break;
            }
        }
        return $return;
    }
}

?>