<?php
################################################################################
#                                                                              #
# Webmoney XML Interfaces parser by Alex Polushin                              #
#                                                                              #
# Updates and new versions: http://my-tools.net/wmxi/                          #
#                                                                              #
# Server requirements:                                                         #
#  - Enabled XML support                                                       #
#                                                                              #
# History of changes:                                                          #
# 2009.01.16                                                                   #
# - alternative version of the parser by (Alex Polushin)                       #
#                                                                              #
################################################################################


# AlexParser class
class AlexParser {

	var $parser_encoding = "UTF-8";
	var $parser;
	var $multitag;
	var $error_code;
	var $error_string;
	var $current_line;
	var $current_column;
	var $datas;
	var $data;


	function _change_encoding($data, $encoding) {
		$result = array();

		foreach($data as $k => $v) {
			$value = is_array($v) ? $this->_change_encoding($v, $encoding) : mb_convert_encoding($v, $encoding, $this->parser_encoding);
			$result[$k] = $value;
		}

		return $result;
	}


	function _tagOpen($parser, $tag, $attribs) {
		$this->datas[] = &$this->data;
		if ($tag==$this->multitag) {
			$this->data[$tag][] = array();
			$this->data = &$this->data[$tag][count($this->data[$tag])-1];
		} else
		if (isset($this->data[$tag])) {
			if (!isset($this->data[$tag][0])) {
				$t = &$this->data[$tag];
				unset($this->data[$tag]);
				$this->data[$tag][] = &$t;
				unset($t);
			}
			$this->data[$tag][] = array();
			$this->data = &$this->data[$tag][count($this->data[$tag])-1];
		} else {
			$this->data[$tag] = array();
			$this->data = &$this->data[$tag];
		}
		$this->data['#'] = '';
		foreach($attribs as $attr => $val) {
			$this->data["@$attr"] = $val;
		}
	}


	function _tagClose($parser, $tag) {
		$this->data = &$this->datas[count($this->datas)-1];
		array_pop($this->datas);
	}


	function _tagData($parser, $cdata) {
		$this->data['#'] .= $cdata;
	}


	function Parse($data, $multitag = '', $encoding = "UTF-8") {
		if (!$this->parser = @xml_parser_create($this->parser_encoding)) {
			$this->parser = xml_parser_create();
		}
		$this->datas = array();
		$this->data = array();
		$this->multitag = $multitag;
		xml_set_object($this->parser, $this);
		xml_parser_set_option($this->parser, XML_OPTION_SKIP_WHITE, 1);
		xml_parser_set_option($this->parser, XML_OPTION_CASE_FOLDING, 0);
		xml_set_element_handler($this->parser, '_tagOpen', '_tagClose');
		xml_set_character_data_handler($this->parser, '_tagData');
		if (!xml_parse($this->parser, $data)) {
			$this->data = array();
			$this->error_code = xml_get_error_code($this->parser);
			$this->error_string = xml_error_string($this->error_code);
			$this->current_line = xml_get_current_line_number($this->parser);
			$this->current_column = xml_get_current_column_number($this->parser);
		} else {
			if (count($this->data)==1)
				$this->data = reset($this->data);
		}
		xml_parser_free($this->parser);
		$this->data = $this->_change_encoding($this->data, $encoding);
		return $this->data;
	}


}
# AlexParser class

?>